# Bonito

Backend for Sketch Engine, frontend for Manatee. Also a tuna.

## Deploying to beta.sketchengine.eu

1. Checkout beta branch.
1. Commit your changes.
1. Run tests (see below).
1. Add a new tag (if you are adding a new feature, increase the minor version and put `new feature` into the commit message together with an explanation; if you fix a bug or do a minor change, increase the patch number).
1. Push the commits together with the tag into origin beta. Currently, we don't use branching and pull requests. Master branch is used for old Bonito version.
1. Go to [GitLab CI](https://gitlab.sketchengine.co.uk/ske/bonito/-/pipelines) and wait until packages are built.
1. Login to toad3 (beta.sketchengine.eu is currently running there) and update the new package with `sudo dnf update bonito`
1. Check the installation, e.g. open [this link](https://beta.sketchengine.eu/bonito/run.cgi/corp_info?corpname=preloaded/bnc2_tt21) and look at `api_version`.

## Deploying to production (app.sketchengine.eu)

1. Follow points 1. to 5. from above.
2. Login to toad0 and update all Bonito instances on our production infrastructure with `sudo octopus_dnf update bonito`.
3. You will need sudo for toad0 and a passphrase for the distributed dnf: you will find it in skepass. Ask someone where to find skepass.

[More about](https://dev.sketchengine.co.uk/wiki/Octopus) our infrastructure nicknamed Octopus.

## Tests

There are a few files in `tests` directory. `bonito.conf` is for testing API methods, `export.conf` for testing export of the methods in various formats, `eurlex.conf` for testing EUR-Lex corpus and `focloir.conf` is a specific test for [Irish corpus](https://dev.sketchengine.co.uk/wiki/BonitoTests).

It is usually enough to run tests from `bonito.conf`.

Run tests with this command:
```cat tests/bonito.conf | python test_bonito.py <url-to-bonito-instance> <username> <password> -l <login-url>```

E.g.
```cat tests/bonito.conf | python test_bonito.py https://beta.sketchengine.eu/bonito <username> <password> -l https://app.sketchengine.eu/ca/api/session```

If you run test on beta.sketchengine.eu, mind that in `bonito.conf` some tests are for corpora not available on beta so they will likely fail.
